#!/usr/local/bin/perl

require "bbs/Library/cgi-lib.pl";
print &PrintHeader;

&ReadParse;

$mode = $in{"mode"};
if ($mode eq "new") {
    &PrintNewPage;
} elsif ($mode eq "loginscreen") {
    &LoginScreen;
} elsif ($mode eq "login") {
    &Login;
} elsif ($mode eq "updatenew") {
    &UpdateNew;
} elsif ($mode eq "updateedit") {
    &UpdateEdit;
} else {
    &PrintProfiles; 
}

###########################################
#
#  PrintProfiles()
#  Prints out all the profiles
#
###########################################
sub PrintProfiles {

    $page = $in{"page"};
    if ($page eq "") {
	$page = 0;
    }

    $numprofs = $in{"numprofs"};
    if ($numprofs eq "") {
	$numprofs = 10;
    }

    $norcal = $in{"norcal"};

    require "profiles/html_header.pl";

#non-norcal profiles
    if ($norcal eq "false") {
	print "<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Non-NorCal Profiles</font></h3>\n";
	print "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=\"2\"><a href=\"profiles.cgi\">NorCal profiles</a></font></p>";

	opendir(PROFILESDIR, "profiles");
	@files = sort(grep(/\.nprof/, readdir(PROFILESDIR)));
	closedir(PROFILESDIR);

#norcal profiles
    } else {
	print "<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Personal Profiles</font></h3>\n";
	print "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=\"2\"><a href=\"profiles.cgi?norcal=false\">Non-NorCal profiles</a></font></p>";

	opendir(PROFILESDIR, "profiles");
	@files = sort(grep(/\.prof/, readdir(PROFILESDIR)));
	closedir(PROFILESDIR);
}

    $pageline = "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Page: ";
#$numfiles is the current profile that it's on

    $numfiles = 0;   
    $oldfile = "";
    $newfile = "";
    @temp = @files;
    while (scalar(@temp) > 0) {
	$file = shift(@temp);
	if ($page == $numfiles/$numprofs) {
	    $pageline .= "<b>";

#	    $pageline .= diff1($file, $oldfile);
	    $pageline .= substr($file, 0, 3);
	    $pageline .= " - ";
	    for (2 .. $numprofs) {
		$newfile = shift(@temp);
		$numfiles++;
	    }
#	    $pageline .= substr($newfile, 0, 
#				1 + length(LCS($file, $oldfile)));
	    $pageline .= substr($newfile, 0, 3);

	    $pageline .= "</b> | ";
	    
	    

	} elsif ($numfiles % $numprofs == 0)  {
	    $newpage = $numfiles / $numprofs;
	    if ($norcal eq "false") {
		$pageline .= "<a href=\"profiles.cgi?page=$newpage&numprofs=$numprofs&norcal=$norcal\">";
	    } else {

		$pageline .= "<a href=\"profiles.cgi?page=$newpage&numprofs=$numprofs\">";
	    }

#	    $pageline .= diff1($file, $oldfile);
	    $pageline .= substr($file, 0, 3);
	    $pageline .= " - ";
	    for (2 .. $numprofs) {
		$newfile = shift(@temp);
	        $numfiles++;
	    }
#	    $pageline .= substr($newfile, 0, 
#				1 + length(LCS($file, $oldfile)));
	    $pageline .= substr($newfile, 0, 3);

	    $pageline .= "</a> | ";
	}
	$oldfile = $newfile;
	$numfiles++;
    }

    $pageline = substr($pageline, 0, length($pageline) - 2);
    $pageline .= "</font></p>\n";
    print $pageline;

    $counter = 0;
    foreach $file (@files) {
	if (($counter >= $page * $numprofs) && 
	    ($counter <= $page * $numprofs + $numprofs - 1)) {
	    PrintProfile ($file);
	} elsif ($counter > $page * $numprofs + 4) {
	    last;
	}
	$counter++;
    }

    print $pageline;

    print "<hr>\n";
    print "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=\"2\"><a href=\"profiles.cgi?mode=new\">Post a new profile</a><br>";
    print "<a href=\"profiles.cgi?mode=loginscreen\">Change or delete an exising profile</a></font></p>\n";

    require "profiles/html_footer.pl";

}

###########################################
#
#  PrintProfile($filename)
#  Prints out one person's profile
#
###########################################
sub PrintProfile {
    local ($filename) = @_;
    open (MESSAGEFILE, "profiles/$filename");
    
    for (1 .. 2) {
	<MESSAGEFILE>;
    }

    print("<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=\"2\">");

    chomp($nickname = <MESSAGEFILE>);
    chomp($name = <MESSAGEFILE>);
    chomp($email = <MESSAGEFILE>);
    chomp($city = <MESSAGEFILE>);
    chomp($song = <MESSAGEFILE>);
    chomp($hangout = <MESSAGEFILE>);
    chomp($picture = <MESSAGEFILE>);

    for (1 .. 5) {
	<MESSAGEFILE>;
    }
    $additional = "";
    while (chomp($line = <MESSAGEFILE>)) {
	if ($line) {
	    $additional .= "$line<br>";
	}
    }
    close PROFILE;

    if ($picture) {
	$name .= " [<a href=\"$picture\">pic</a>]";
    }

    &PrintProfileItem("Nickname", $nickname);
    &PrintProfileItem("Name", $name);
    &PrintProfileItem("Email", $email);
    &PrintProfileItem("City", $city);
    &PrintProfileItem("Fav Song", $song);
    &PrintProfileItem ("DDR Hangout", $hangout);
    &PrintProfileItem ("Additional", $additional);
    print ("</font></p>\n");

}

###########################################
#
#  PrintProfileItem($heading, $line)
#  Prints a "Header: Line" pair if necessary
#
###########################################
sub PrintProfileItem {
    local ($heading) = shift;
    local ($line) = shift;

    chomp ($line);
    if ($line) {
	if ($heading eq "Email") {
	    print ("<b>$heading</b>: <a href=\"mailto:$line\">$line</a><br>\n");
	} elsif ($heading eq "Additasdfionall") {
	    print ("<b>$heading</b>: $line<br>");
	    while ($line = <MESSAGEFILE>) {
		print ("$line<br>");
	    }

	} else {
	    print ("<b>$heading</b>: $line<br>\n");
	}
    }
}

#########################################
#
# LCS(str1, str2)
# Returns the longest common substring, starting from index 0
#
#########################################
sub LCS {
    local($str1) = shift;
    local($str2) = shift;

    $length = 0;

    while (substr($str1, 0, $length + 1) eq (substr($str2, 0, $length + 1))) {
        $length++;
    }
    $str = substr($str1, 0, $length);
    return $str;
}

#######################################
#
# diff1($str1, $str2)
# LCS, concatenated with the following letter of str1
#
#######################################
sub diff1 {
    local($str1) = shift;
    local($str2) = shift;

    $lcs = LCS($str1, $str2);

    $result = $lcs . substr($str1, length($lcs), 1);
    return $result;
}

#########################################
#
#  PrintNewPage()
#  Prints a page for new users to add profiles
#
#########################################
sub PrintNewPage {

    require "profiles/html_header.pl";
    print qq!
<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Enter Your Info</font></h3>
<form method=post action="profiles.cgi">
<table>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Username:
</font></th>
<td><input type=text name=username value="" size=15 maxlength=15></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Password:
</font></th>
<td><input type=password name=password value="" size=15 maxlength=15></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Password:
</font></th>
<td><input type=password name=password2 value="" size=15 maxlength=15>
<font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2> (confirm)</font></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Nickname:
</font></th>
<td><input type=text name=nickname value="" size=30 maxlength=40></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Real Name:
</font></th>
<td><input type=text name=name value="" size=30 maxlength=40></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Email:
</font></th>
<td><input type=text name=email value="" size=30 maxlength=40></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Picture:
</font></th>
<td><input type=text name=picture value="" size=30 maxlength=100></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>City:
</font></th>
<td><input type=text name=city value="" size=30 maxlength=40></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>NorCal:
</font></th>
<td><input type=checkbox name=norcal value="norcal">
<font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
Check if you are from Northern California</font></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Fav Song:
</font></th>
<td><input type=text name=song value="" size=30 maxlength=300></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
DDR Hangout:</font></th>
<td><input type=text name=hangout value="" size=30 maxlength=40></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
Additional</font></th>
<td><textarea cols=45 rows=4 name=additional></textarea></td>
</tr>
</table>

<input type=hidden name=mode value="updatenew">

<center>
<hr>
<input type=submit name=update value="Submit Profile">
<input type=reset value="Clear Values">
<hr>
</form>
</center>

<font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
<p>If you would like any of this information to remain <a href="privacy.html">private</a>, leave the field blank. However, username, password, and nickname are required.</p>
</font>
	!;
    require "profiles/html_footer.pl";

}

########################################################
#
#  UpdateNew()
#  Adds a new file to profiles
#
########################################################
sub UpdateNew {

    local($username) = $in{"username"};
    local($password) = $in{"password"};
    local($password2) = $in{"password2"};
    local($nickname) = $in{"nickname"};
    local($name) = $in{"name"};
    local($email) = $in{"email"};
    local($city) = $in{"city"};
    local($norcal) = $in{"norcal"};
    local($song) = $in{"song"};
    local($hangout) = $in{"hangout"};
    local($picture) = $in{"picture"};
    local($additional) = $in{"additional"};
    local($file) = "";
    
    opendir (PROFILESDIR, "profiles") || &CgiDie ("error opening profiles directory");
    @files = sort(grep(/.prof/, readdir(PROFILESDIR)));
    closedir (PROFILESDIR);

    #convert nickname to filename
    $filename = lc ($nickname);
    $filename =~ s/ //gi;

    if ($norcal eq "norcal") {
	$filename .= ".prof";
    } else {
	$filename .= ".nprof";
    }

    #check for existing username or filename
    $username =~ s/ //gi;
    foreach $tempfile (@files) {
	open (PROFILE, "profiles/$tempfile") || &CgiDie ("error opening $tempfile");
	chop($user = <PROFILE>);
	close (PROFILE);
	if (($username eq $user) || ($filename eq $tempfile)) {
	    $file = $tempfile;
	    last;
	}
    }

    if ($username eq $user) {
	#duplicate username exists
	$create_msg_error = "hello";
	&CgiDie ("duplicate user name: $user\n");
    } elsif ($filename eq $file) {
	&CgiDie ("duplicate nickname: $nickname\n");
    } elsif ($password ne $password2) {
	&CgiDie ("passwords do not match\n");
    } elsif ($password eq "") {
	&CgiDie ("password field required\n");
    } elsif ($username eq "") {
	&CgiDie ("username field required\n");
    } elsif (length($password) < 3) {
	&CgiDie ("password must be longer than 2 characters");
    } elsif ($nickname eq "") {
	&CgiDie ("nickname field required\n");
    } elsif (index($nickname , "\"") != -1) {
	&CgiDie ("no quotes(\") allowed in nickname");
    }

    $crypt = crypt($password, substr($password, 0, 2));

    open (PROFILE, ">profiles/$filename") || CgiDie("error");
    print (PROFILE "$username\n");
    print (PROFILE "$crypt\n");
    print (PROFILE "$nickname\n");
    print (PROFILE "$name\n");
    print (PROFILE "$email\n");
    print (PROFILE "$city\n");
    print (PROFILE "$song\n");
    print (PROFILE "$hangout\n");
    print (PROFILE "$picture\n");
    print (PROFILE "$ENV{'REMOTE_ADDR'}\n"); #for extra fields if necessary
    print (PROFILE "\n");
    print (PROFILE "\n");
    print (PROFILE "\n");
    print (PROFILE "\n");
    print (PROFILE "$additional\n");
    close PROFILE;

    require "profiles/html_header.pl";
    print "<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Personal Profiles
</font></h3>\n";
    print "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Your profile has been submitted.</p>";

    if ($norcal ne "norcal") {
	print "<p><a href=\"profiles.cgi?norcal=false\">Return to profiles</a></p>\n";
    } else {
	print "<p><a href=\"profiles.cgi\">Return to profiles</a></p>\n";
    }
    require "profiles/html_footer.pl";
    
}

################################################
#
#  LoginScreen()
#  Prints out a username/password form
#
################################################
sub LoginScreen {

    require "profiles/html_header.pl";

    print qq!
<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Profile Logon</font></h3>
<form method=post action="profiles.cgi">
<table>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Username:</font></th>
<td><input type=text name=username size=15 maxlength=15></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Password:</font></th>
<td><input type=password name=password size=15 maxlength=15></td>
</tr>
</table>

<input type=hidden name=mode value="login">

<center>
<hr>
<input type=submit name=update value="Login">
<input type=reset value="Clear Values">
<hr>
</form>
</center>
!;

    require "profiles/html_footer.pl";

}

##############################
#
# Login()
# Checks if the login/password combination is correct
#
##############################
sub Login {

    local($username) = $in{"username"};
    local($password) = $in{"password"};

    if ($username eq "") {
	&CgiDie("username is required");
    } elsif ($password eq "") {
	&CgiDie("password is required");
    }

    opendir (PROFILESDIR, "profiles");
    @files = sort(grep(/.prof/, readdir(PROFILESDIR)));
    closedir (PROFILESDIR);

    $username =~ s/ //gi;
    foreach $tempfile (@files) {
	open (PROFILE, "profiles/$tempfile");
	chop ($user = <PROFILE>);
	close (PROFILE);
	if (lc($username) eq lc($user)) {
	    $oldfile = $tempfile;
	    last;
	}
    }

    if (lc($username) ne lc($user)) {
	&CgiDie ("username not found");
    }

    $crypt = crypt($password, substr($password, 0, 2));

    open (PROFILE, "profiles/$oldfile");
    <PROFILE>;
    chomp ($passhash = <PROFILE>);
    if ($crypt ne $passhash) {
	&CgiDie("invalid password\n");
    }
    chomp ($nickname = <PROFILE>);
    chomp ($name = <PROFILE>);
    chomp ($email = <PROFILE>);
    chomp ($city = <PROFILE>);
    chomp ($song = <PROFILE>);
    chomp ($hangout = <PROFILE>);
    chomp ($picture = <PROFILE>);

    for (1 .. 5) {
	<PROFILE>;
    }

    $additional = "";
    while (chomp($line = <PROFILE>)) {
	if ($line) {
	    $additional .= "$line\n";
	}
    }
    close PROFILE;

    if (index($oldfile, "\.prof") != -1) {
	$norcal = "norcal";
    }

    require "profiles/html_header.pl";
    print qq!
<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Edit Your Info</font></h3>
<form method=post action="profiles.cgi">

<table>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Nickname:
</font></th>
<td><input type=text name=nickname value="$nickname" size=30 maxlength=40></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Real Name:
</font></th>
<td><input type=text name=name value="$name" size=30 maxlength=40></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Email:
</font></th>
<td><input type=text name=email value="$email" size=30 maxlength=40></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
Picture:</font></th>
<td><input type=text name=picture value="$picture" size=30 maxlength=100></td>
</tr>


<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>City:
</font></th>
<td><input type=text name=city value="$city" size=30 maxlength=40></td>
</tr>
<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>NorCal:
</font></th> !;

if ($norcal eq "norcal") {
    print "<td><input type=checkbox name=norcal checked value=\"norcal\">\n";
} else {
    print "<td><input type=checkbox name=norcal value=\"norcal\">\n";
}

print qq!
<font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
Check if you are from Northern California</font></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Fav Song:
</font></th>
<td><input type=text name=song value="$song" size=30 maxlength=300></td>
</tr>

<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
DDR Hangout:</font></th>
<td><input type=text name=hangout value="$hangout" size=30 maxlength=40></td>
</tr>


<tr>
<th align=right><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>
Additional</font></th>
<td><textarea cols=45 rows=4 name=additional>$additional</textarea></td>
</tr>
</table>

<input type=hidden name=mode value="updateedit">
<input type=hidden name=oldfile value="$oldfile">
<input type=hidden name=password value="$password">
<input type=hidden name=password2 value="$password">
<input type=hidden name=username value="$username">

<center>
<hr>
<input type=submit name=update value="Edit Profile">
<input type=submit name=delete value ="Delete Profile">
<input type=reset value="Clear Values">
<hr>
</form>
</center>!;


    
    require "profiles/html_footer.pl";

}

#######################################
#
# UpdateEdit()
# Prints a confirmation that it was updated
#
#######################################

sub UpdateEdit {

    local ($file) = $in{"oldfile"};
    unlink "profiles/$file";
    if ($in{"delete"} eq "") {
	&UpdateNew;
    } else {
	require "profiles/html_header.pl";
	print "<h3><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\">Personal Profiles</font></h3>\n";
	print "<p><font face=\"VERANDA,ARIAL,GENEVA,HELVETICA\" size=2>Your profile has been deleted.</p>";
	print "<p><a href=\"profiles.cgi\">Return to profiles</a></p>\n";
	require "profiles/html_footer.pl";

    }
}




